/*
** mSQL Module Header File
*/


/***********************************************************************
** Standard header preamble.  Ensure singular inclusion, setup for
** function prototypes and c++ inclusion
*/

#ifndef MOD_MSQL_H

#define MOD_MSQL_H 1

#if defined(__STDC__) || defined(__cplusplus)
#  define __ANSI_PROTO(x)       x
#else
#  define __ANSI_PROTO(x)       ()
#endif

#ifdef __cplusplus
extern "C" {
#endif



/***********************************************************************
** Macro Definitions
*/


/***********************************************************************
** Type Definitions
*/


/***********************************************************************
** Function Prototypes
*/

int doMsqlConnect();
int doMsqlClose();
int doMsqlSelectDB();
int doMsqlQuery();
int doMsqlStoreResult();
int doMsqlFreeResult();
int doMsqlFetchField();
int doMsqlFetchRow();
int doMsqlFieldSeek();
int doMsqlDataSeek();
int doMsqlListDBs();
int doMsqlListTables();
int doMsqlInitFieldList();
int doMsqlListField();
int doMsqlNumRows();
int doMsqlNumFields();
int doMsqlEncode();
int doMsqlLoadConfigFile();

int doMsqlUnixTimeToDate();
int doMsqlDateToUnixTime();
int doMsqlUnixTimeToTime();   
int doMsqlTimeToUnixTime();

int doMsqlSumTimes();
int doMsqlDateOffset();
int doMsqlDiffTimes();
int doMsqlDiffDates();


/***********************************************************************
** Standard header file footer.  
*/

#ifdef __cplusplus
	}
#endif /* __cplusplus */
#endif /* file inclusion */


static e_extern msql_externs [] = {
        { "msqlConnect", doMsqlConnect, "_doMsqlConnect", -1, {0} },
        { "msqlClose", doMsqlClose, "_doMsqlClose", 1, { EMBER_TYPE_INT,0} },
        { "msqlSelectDB", doMsqlSelectDB, "_doMsqlSelectDB", 2, 
		{ EMBER_TYPE_INT, EMBER_TYPE_TEXT,0} },
        { "msqlQuery", doMsqlQuery, "_doMsqlQuery", 2, 
		{ EMBER_TYPE_INT, EMBER_TYPE_TEXT,0} },
        { "msqlStoreResult", doMsqlStoreResult, "_doMsqlStoreResult", 0, { 0} },
        { "msqlFreeResult", doMsqlFreeResult, "_doMsqlFreeResult", 1, 
		{ EMBER_TYPE_INT,0} },
        { "msqlFetchRow", doMsqlFetchRow, "_doMsqlFetchRow", 1, 
		{ EMBER_TYPE_INT,0} },
        { "msqlNumRows", doMsqlNumRows, "_doMsqlNumRows", 1, 
		{ EMBER_TYPE_INT,0} },
        { "msqlDataSeek", doMsqlDataSeek, "_doMsqlDataSeek", 2, 
		{ EMBER_TYPE_INT, EMBER_TYPE_INT,0} },
        { "msqlFetchField", doMsqlFetchField, "_doMsqlFetchField", 1, 
		{ EMBER_TYPE_INT,0} },
        { "msqlFieldSeek", doMsqlFieldSeek, "_doMsqlFieldSeek", 2, 
		{ EMBER_TYPE_INT, EMBER_TYPE_INT,0} },
        { "msqlNumFields", doMsqlNumFields, "_doMsqlNumFields", 1, 
		{ EMBER_TYPE_INT,0} },
        { "msqlListDBs", doMsqlListDBs, "_doMsqlListDBs", 1, 
		{ EMBER_TYPE_INT,0} },
        { "msqlListTables", doMsqlListTables, "_doMsqlListTables", 1, 
		{ EMBER_TYPE_INT,0} },
        { "msqlInitFieldList", doMsqlInitFieldList, "_doMsqlInitFieldList", 2, 
		{ EMBER_TYPE_INT, EMBER_TYPE_TEXT, 0} },
        { "msqlListField", doMsqlListField, "_doMsqlListField", 0, { 0} },
        { "msqlEncode", doMsqlEncode, "_doMsqlEncode", 1, 
		{ EMBER_TYPE_TEXT,0} },
        { "msqlDateToUnixTime", doMsqlDateToUnixTime, "_doMsqlDateToUnixTime",1,
		{ EMBER_TYPE_TEXT,0} },
        { "msqlUnixTimeToDate", doMsqlUnixTimeToDate, "_doMsqlUnixTimeToDate",1,
		{ EMBER_TYPE_INT,0} },
        { "msqlTimeToUnixTime", doMsqlTimeToUnixTime, "_doMsqlTimeToUnixTime",1,
		{ EMBER_TYPE_TEXT,0} },
        { "msqlUnixTimeToTime", doMsqlUnixTimeToTime, "_doMsqlUnixTimeToTime",1,
		{ EMBER_TYPE_INT,0} },
        { "msqlSumTimes", doMsqlSumTimes, "_doMsqlSumTimes", 2, 
		{ EMBER_TYPE_TEXT, EMBER_TYPE_TEXT, 0} },
        { "msqlDateOffset", doMsqlDateOffset, "_doMsqlDateOffset", 4, 
		{ EMBER_TYPE_TEXT, EMBER_TYPE_INT, EMBER_TYPE_INT,
		  EMBER_TYPE_INT, 0} },
        { "msqlDiffTimes", doMsqlDiffTimes, "_doMsqlDiffTimes", 2, 
		{ EMBER_TYPE_TEXT, EMBER_TYPE_TEXT, 0} },
        { "msqlDiffDates", doMsqlDiffDates, "_doMsqlDiffDates", 2, 
		{ EMBER_TYPE_TEXT, EMBER_TYPE_TEXT, 0} },
        { "msqlLoadConfigFile", doMsqlLoadConfigFile, "_doMsqlLoadConfigFile",1,
		{ EMBER_TYPE_TEXT, 0}},

	{ NULL }
};

